call plug#begin(stdpath('data') . '/plugged')

" Themes
Plug 'morhetz/gruvbox'

"Timmy Popester
Plug 'tpope/vim-surround'
Plug 'tpope/vim-repeat'
Plug 'tpope/vim-commentary'
Plug 'tpope/vim-fugitive'
Plug 'jiangmiao/auto-pairs'

" Nav
Plug 'rhysd/clever-f.vim' 
Plug 'easymotion/vim-easymotion'

" Utilities
" Plug 'Yggdroot/LeaderF', { 'do': ':LeaderfInstallCExtension' }
" Plug 'mhinz/vim-startify'
" Plug 'mbbill/undotree'
" Plug 'junegunn/vim-easy-align'
" Plug 'famiu/nvim-reload'
" Plug 'kyazdani42/nvim-web-devicons'
" Plug 'nvim-lua/plenary.nvim'
" Plug 'nvim-lua/popup.nvim'
" Plug 'nvim-telescope/telescope.nvim'

" Languages
Plug 'dag/vim-fish', { 'for' : 'fish' }

" Stuff to maybe install later

Plug 'airblade/vim-gitgutter'  " This one is going to depend on whether vim still remains snappy

" Plug 'ionide/Ionide-vim', {    " Are we really going to try and develop on vim?
"       \ 'do':  'make fsautocomplete',
"       \}
" Plug 'autozimu/LanguageClient-neovim', { 'branch': 'next', 'do': 'bash install.sh' }


call plug#end()

" color gruvbox

set autochdir
set splitbelow
set splitright
set tabstop=4
set shiftwidth=4
set expandtab
set softtabstop=4
set nowrap
set ignorecase
set smartcase
set noswapfile
set nobackup
set hidden
set wildmenu
set shell=/bin/bash
set clipboard=unnamedplus

let mapleader = " "

nnoremap d <C-d>
nnoremap u <C-u>
nnoremap Y y$
nnoremap vv ^vg_
noremap \ q
noremap $ g_
nnoremap ' `
nnoremap ` '
nnoremap - :Ex<CR>
map , <Plug>(easymotion-prefix)

tnoremap <A-e> <C-\><C-n>
nnoremap <silent> <Leader>/ :nohlsearch<CR>

" Plugins

" Clever-F
let g:clever_f_fix_key_direction = 1

" EasyMotion
let g:EasyMotion_startofline = 0
let g:EasyMotion_keys = 'asdfjklhgwueiroxnmvczqp'

" Easy Align
xmap ga <Plug>(EasyAlign)
nmap ga <Plug>(EasyAlign)
